summaryrefslogtreecommitdiff
path: root/tests/rm
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2011-08-19 17:51:45 +0200
committerJim Meyering <meyering@redhat.com>2011-08-19 18:21:06 +0200
commit0ba576979a10a11e5652fd155266464b1e784892 (patch)
tree04b1da5dcef655178b0199c8d7aa874d386c77e6 /tests/rm
parent036a9c69099f372ca581ce8b5c22e88656a2b478 (diff)
downloadcoreutils-0ba576979a10a11e5652fd155266464b1e784892.tar.xz
rm, du, chmod, chown, chgrp: use much less memory for large directories
For details, see the gnulib commit, http://git.sv.gnu.org/cgit/gnulib.git/commit/?id=47cb657e * tests/rm/4-million-entry-dir: New test. * tests/Makefile.am (TESTS): Add it. * NEWS (Bug fixes): Mention it. * gnulib: Update to latest to get the required fts fixes.
Diffstat (limited to 'tests/rm')
-rwxr-xr-xtests/rm/4-million-entry-dir35
1 files changed, 35 insertions, 0 deletions
diff --git a/tests/rm/4-million-entry-dir b/tests/rm/4-million-entry-dir
new file mode 100755
index 000000000..23130a68e
--- /dev/null
+++ b/tests/rm/4-million-entry-dir
@@ -0,0 +1,35 @@
+#!/bin/sh
+# in coreutils-8.12, this would have required ~1GB of memory
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ rm
+
+very_expensive_
+
+# Put 4M files in a directory.
+mkdir d && cd d || framework_failure_
+seq 4000000|xargs touch || framework_failure_
+
+cd ..
+
+# Restricted to 50MB, rm from coreutils-8.12 would fail with a
+# diagnostic like "rm: fts_read failed: Cannot allocate memory".
+ulimit -v 50000
+rm -rf d || fail=1
+
+Exit $fail